! Just set up the initial conditions of the nozzle,
! such as the density, pressure, velocity and internal energy.
!

      Subroutine Init_cons(V,lmax,min,mx,my)
      ! Implicit none
      Integer lmax,mx,my
      Real V(lmax,mx+1,my+1)
      Real p(mx+1,my+1)
    	  Real min
      Integer l,i,j

! Again, distributing  V *(*,*,BLOCK) insures 
! incoming mapping is to be left alone.
! The third dimension of P is aligned with
! the third dimension of V.

!HPF$ PROCESSORS PROC(NUMBER_OF_PROCESSORS())
!HPF$ DISTRIBUTE  V *(*,*,BLOCK) onto *PROC
!HPF$ ALIGN (*,:) with V(*,*,:) :: p
       write(6,*) 'Enter inlet mach no.'
      read(5,*) min

      Forall(j=2:my) P(1,j)=1.0/(min**2/2.0 *(1.4-1.0)
     $  +1.0)**(1.4/0.4)
    		write(6,*) 'Inlet pressure is:',p(1,2)
       Forall(j=2:my) V(1,1,j)=P(1,j)*(1.0
     $  + (1.4-1.0)/2.0*min**2)

         Forall(j=2:my) V(2,1,j)=V(1,1,j)*min
     $ *sqrt(1.4*p(1,j)/V(1,1,j))

          Forall(j=2:my) V(3,1,j)=0.0
       Forall(j=2:my)    V(4,1,j)=p(1,j)/(0.4) + 0.5*V(1,1,j)
     $ *(V(2,1,j)**2 / V(1,1,j)**2)

       Forall(l=1:lmax,i=2:mx+1,j=2:my) V(l,i,j)=V(l,1,j)


       End subroutine
       


