! This routine computes the local time step, which varies
! varies with mesh spacing.  This provides much quicker
! convergence than the global time step.



      Subroutine time_step(V,dt,p,xloc,yloc,cfl,lmax,mx,my)
      ! Implicit none
      Integer lmax,mx,my
      Real V(lmax,mx+1,my+1)
      Real xloc(mx,my+1),yloc(mx,my+1)
      Real p(mx+1,my+1)
      Real  dt(mx,my+1)
      Real cfl
      Integer i,j,l

! Simply distribute and align as done in the calling routine

!HPF$ PROCESSORS PROC(NUMBER_OF_PROCESSORS())
!HPF$ DISTRIBUTE  V *(*,*,BLOCK) onto *PROC
!HPF$ ALIGN (*,:) with *V(*,*,:) :: xloc,yloc,dt
!HPF$ ALIGN (*,:) with *V(*,*,:) :: p      

    	
      Forall(i=2:mx,j=2:my)
      dt(i,j)=cfl/(abs(V(2,i,j)/V(1,i,j))/(xloc(i,j)-
     $ xloc(i-1,j))
     $ + abs(V(3,i,j)/V(1,i,j))/(yloc(i,j)-yloc(i,j-1)) +
     $ sqrt(1.4*p(i,j)/v(1,i,j))*sqrt(1.0/(xloc(i,j)-xloc(i-1,j))**2
     $ +1.0/(yloc(i,j)-yloc(i,j-1))**2))
      End Forall 
      End subroutine

